<?php
/**
 * DLE MultiXfield
 *
 * @copyright 2018 LazyDev
 * @version   1.0.0
 * @link      https://lazydev.pro
 */

if (!defined('DATALIFEENGINE') || !defined('LOGGED_IN')) {
	die('Hacking attempt!');
}

if (!$user_group[$member_id['user_group']]['admin_complaint']) {
	msg('error', $lang['index_denied'], $lang['index_denied']);
}

include ENGINE_DIR . '/dle_multixfield/config/config.php';
include ENGINE_DIR . '/dle_multixfield/language/language.lng';

$all_xfield = xfieldsload();
$xfield = ['-' => '-'];

foreach ($all_xfield as $key => $val) {
	$xfield[$val[0]] = $val[1];
}

function showLazyRow($title = '', $description = '', $field = '')
{
echo <<<HTML
	<tr>
        <td class="col-xs-6 col-sm-6 col-md-7">
			<h6 class="media-heading text-semibold">{$title}</h6>
			<span class="text-muted text-size-small hidden-xs">{$description}</span>
		</td>
        <td class="col-xs-6 col-sm-6 col-md-5">{$field}</td>
	</tr>
HTML;
}
	
function makeLazyDropDown($options, $name, $selected)
{
	$output = "<select class=\"uniform\" name=\"$name\">\r\n";
	foreach ($options as $value => $description) {
		$output .= "<option value=\"$value\"";
		if ($selected == $value) {
			$output .= " selected ";
		}
		$output .= ">$description</option>\n";
	}
	$output .= "</select>";
	return $output;
}

function makeLazyCheckBox($name, $selected)
{
	$selected = $selected ? 'checked' : '';
	return "<input class=\"switch\" type=\"checkbox\" name=\"{$name}\" value=\"1\" {$selected}>";
}

function showLazySelect($name, $select, $placeholder = '')
{
	return "<select name=\"{$name}\" class=\"form-control custom-select\" data-placeholder=\"{$placeholder}\" multiple>" . $select . "</select>";
}

function lazySelect($data)
{
	foreach ($data[1] as $key => $val) {
		if ($data[2]) {
			$output .= "<option value=\"{$key}\"";
		} else {
			$output .= "<option value=\"{$val}\"";
		}
		if (is_array($data[3])) {
			foreach ($data[3] as $element) {
				if ($data[2] && $element == $key) {
					$output .= " selected ";
				} elseif (!$data[2] && $element == $val) {
					$output .= " selected ";
				}
			}
		} elseif ($data[2] && $data[3] == $key) {
			$output .= " selected ";
		} elseif (!$data[2] && $data[3] == $val) {
			$output .= " selected ";
		}
		$output .= ">{$val}</option>\n";
	}
	$input_elemet = $data[5] ? ' disabled' : '';
	$input_elemet .= $data[4] ? ' multiple' : '';
	$input_elemet .= $data[6] ? " data-placeholder=\"{$data[6]}\"" : '';
return <<<HTML
<select name="{$data[0]}" class="form-control custom-select" {$input_elemet}>
	{$output}
</select>
HTML;
}

function showLazyInput($data)
{
	$input_elemet = $data[3] ? " placeholder=\"{$data[3]}\"" : '';
	$input_elemet .= $data[4] ? ' disabled' : '';
	if ($data[1] == 'range') {
		$class = ' custom-range';
		$input_elemet .= $data[5] ? " step=\"{$data[5]}\"" : '';
		$input_elemet .= $data[6] ? " min=\"{$data[6]}\"" : '';
		$input_elemet .= $data[7] ? " max=\"{$data[7]}\"" : '';
	} elseif ($data[1] == 'number') {
		$class = ' w-9';
		$input_elemet .= $data[5] ? " min=\"{$data[5]}\"" : '';
		$input_elemet .= $data[6] ? " max=\"{$data[6]}\"" : '';
	}
return <<<HTML
	<input type="{$data[1]}" style="float: right;" value="{$data[2]}" class="form-control{$class}" name="{$data[0]}"{$input_elemet}>
HTML;
}

$category = CategoryNewsSelection((count($dle_multixfield_config['category']) > 0 ? $dle_multixfield_config['category'] : 0), 0, false);

echoheader("<i class=\"fa fa-list position-left\"></i><span class=\"text-semibold\">{$dle_multixfield_lang['name']}</span>", $dle_multixfield_lang['settings']);
echo <<<HTML
<form action="" method="post" class="systemsettings">
	<div id="general" class="panel panel-flat">
		<div class="panel-body">{$dle_multixfield_lang['settings']}</div>
		<div class="table-responsive">
			<table class="table table-striped">
HTML;
showLazyRow($dle_multixfield_lang[0], $dle_multixfield_lang[1], showLazySelect('category[]', $category, $dle_multixfield_lang[2]));
showLazyRow($dle_multixfield_lang[3], $dle_multixfield_lang[4], lazySelect(['xfield[]', $xfield, true, $dle_multixfield_config['xfield'], true, false,  $dle_multixfield_lang[3]]));
showLazyRow($dle_multixfield_lang[5], $dle_multixfield_lang[6], showLazyInput(['options[news]', 'number', $dle_multixfield_config['options']['news'] ?: 10, false, false, 1, 100]));
showLazyRow($dle_multixfield_lang[7], $dle_multixfield_lang[8], makeLazyCheckBox('options[index]', $dle_multixfield_config['options']['index']));
echo <<<HTML
			</table>
		</div>
	</div>
	<button type="submit" class="btn bg-teal btn-raised position-left"><i class="fa fa-floppy-o position-left"></i>{$lang['user_save']}</button>
	<button type="button" id="cacheMX" class="btn bg-danger btn-raised" style="float: right;"><i class="fa fa-trash position-left"></i>{$dle_multixfield_lang['cache']}</button>
</form>
<script>
	$(function() {
		$('select[multiple]').chosen({allow_single_deselect: true, no_results_text: '{$dle_multixfield_lang[9]}', width: '300px'});
		
		function ajax_save_option() {
			var data_form = $('form').serialize();
			$.post('/engine/dle_multixfield/admin/ajax/ajax.php', {data_form: data_form, action: 'options', user_hash: '{$dle_login_hash}'}, function(data) {
				data = jQuery.parseJSON(data);
				if (data.error) {
					Growl.error({
						title: 'Ошибка',
						text: data.error
					});
				} else {
					Growl.info({
						title: 'Информация',
						text: data.text
					});
				}
			});
			return false;
		}
		
		$('body').on('submit', 'form', function(e) {
			e.preventDefault();
			ajax_save_option();
			return false;
		});
		
		$('body').on('click', '#cacheMX', function(e) {
			e.preventDefault();
			$.post('/engine/dle_multixfield/admin/ajax/ajax.php', {action: 'cache', user_hash: '{$dle_login_hash}'}, function(data) {
				data = jQuery.parseJSON(data);
				if (data.error) {
					Growl.error({
						title: 'Ошибка',
						text: data.error
					});
				} else {
					Growl.info({
						title: 'Информация',
						text: data.text
					});
				}
			});
			return false;
		});
	});
</script>
HTML;
?>