<?php
/**
 * DLE MultiXfield
 *
 * @copyright 2018 LazyDev
 * @version   1.0.0
 * @link      https://lazydev.pro
 */

@error_reporting(E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);
@ini_set('error_reporting', E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', false);

define('DATALIFEENGINE', true);
define('ROOT_DIR', substr(dirname(__FILE__), 0, -34));
define('ENGINE_DIR', ROOT_DIR . '/engine');

if (file_exists(ENGINE_DIR . '/classes/plugins.class.php')) {
	include_once ENGINE_DIR . '/classes/plugins.class.php';
} else {
	class DLEPlugins
	{
		static public function Check($source = '')
		{
			return $source;
		}
	}
}

include (DLEPlugins::Check(ENGINE_DIR . '/data/config.php'));

date_default_timezone_set($config['date_adjust']);
$_TIME = time();

require_once (DLEPlugins::Check(ENGINE_DIR . '/classes/mysql.php'));
require_once (DLEPlugins::Check(ENGINE_DIR . '/data/dbconfig.php'));
require_once (DLEPlugins::Check(ENGINE_DIR . '/modules/functions.php'));

dle_session();

require_once (DLEPlugins::Check(ENGINE_DIR . '/modules/sitelogin.php'));

include ENGINE_DIR . '/dle_multixfield/language/language.lng';

$_POST['user_hash'] = trim($_POST['user_hash']);
if ($_POST['user_hash'] == '' || $_POST['user_hash'] != $dle_login_hash) {
	echo json_encode(['error' => $dle_multixfield_lang[10]], JSON_UNESCAPED_UNICODE);
	die();
}

if (!$is_logged && $member_id['user_group'] != 1) {
	echo json_encode(['error' => $dle_multixfield_lang[11]], JSON_UNESCAPED_UNICODE);
	die();
}

$action = isset($_POST['action']) ? trim(strip_tags($_POST['action'])) : false;

if ($action == 'options') {
	$data_form = isset($_POST['data_form']) ? $_POST['data_form'] : false;
	if ($data_form) {
		parse_str($data_form, $array_post);
	}
	
	$new_array = [];
	foreach ($array_post as $index => $item) {
		foreach ($item as $key => $value) {
			if (is_array($value)) {
				foreach ($value as $k => $v) {
					if ($v != '' && $v != '-') {
						$v = is_numeric($v) ? intval($v) : strip_tags(stripslashes($v));
						$new_array[$index][$key][] = $v;
					}
				}
			} else {
				if ($value != '' && $value != '-') {
					$value = is_numeric($value) ? intval($value) : strip_tags(stripslashes($value));
					$new_array[$index][$key] = $value;
				}
			}
		}
	}
	
	$handler = fopen(ENGINE_DIR . '/dle_multixfield/config/config.php', "w");
	fwrite($handler, "<?php \n\n//DLE MultiXfield by LazyDev.pro\n\n\$dle_multixfield_config = ");
	fwrite($handler, var_export($new_array, true));
	fwrite($handler, ";\n\n?>");
	fclose($handler);	
	echo json_encode(['text' => $dle_multixfield_lang['options_save']]);
} elseif ($action == 'cache') {
	clear_cache(['news_mx_', 'mxs_']);
	echo json_encode(['text' => $dle_multixfield_lang['cache_result']]);
}
?>