<?php
/**
 * DLE MultiXfield
 *
 * @copyright 2018 LazyDev
 * @version   1.0.0
 * @link      https://lazydev.pro
 */

@error_reporting(E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);
@ini_set('error_reporting', E_ALL ^ E_WARNING ^ E_DEPRECATED ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', false);

define('DATALIFEENGINE', true);
define('ROOT_DIR', substr(dirname(__FILE__), 0, -28));
define('ENGINE_DIR', ROOT_DIR . '/engine');

$is_logged = false;
require_once (ENGINE_DIR . '/classes/plugins.class.php');
include_once (DLEPlugins::Check(ENGINE_DIR . '/modules/functions.php'));

if ($config['lang_' . $config['skin']] && file_exists(DLEPlugins::Check(ROOT_DIR . '/language/' . $config['lang_' . $config['skin']] . '/website.lng'))) {
	include_once (DLEPlugins::Check(ROOT_DIR . '/language/' . $config['lang_' . $config['skin']] . '/website.lng'));
} else {
	include_once (DLEPlugins::Check(ROOT_DIR . '/language/' . $config['langs'] . '/website.lng'));
}

require_once (DLEPlugins::Check(ENGINE_DIR . '/classes/templates.class.php'));

if (strpos($config['http_home_url'], '//') === 0) {
	$config['http_home_url'] = isSSL() ? $config['http_home_url'] = 'https:' . $config['http_home_url'] : $config['http_home_url'] = 'http:' . $config['http_home_url'];
} elseif (strpos($config['http_home_url'], '/') === 0) {
	$config['http_home_url'] = isSSL() ? $config['http_home_url'] = 'https://' . $_SERVER['HTTP_HOST'] . $config['http_home_url'] : 'http://' . $_SERVER['HTTP_HOST'] . $config['http_home_url'];
} elseif(isSSL() && stripos($config['http_home_url'], 'http://') !== false) {
	$config['http_home_url'] = str_replace('http://', 'https://', $config['http_home_url']);
}

if (substr($config['http_home_url'], -1, 1) != '/') {
	$config['http_home_url'] .= '/';
}

dle_session();
require_once (DLEPlugins::Check(ENGINE_DIR . '/modules/sitelogin.php'));

if ($_REQUEST['skin']) {
	$_REQUEST['skin'] = $_REQUEST['dle_skin'] = trim(totranslit($_REQUEST['skin'], false, false));
}

if ($_REQUEST['dle_skin']) {
	$_REQUEST['dle_skin'] = trim(totranslit($_REQUEST['dle_skin'], false, false));
	
	if($_REQUEST['dle_skin'] && @is_dir(ROOT_DIR . '/templates/' . $_REQUEST['dle_skin'])) {
		$config['skin'] = $_REQUEST['dle_skin'];
	} else {
		$_REQUEST['dle_skin'] = $_REQUEST['dle_skin'] = $config['skin'];
	}
} elseif ($_COOKIE['dle_skin']) {
	$_COOKIE['dle_skin'] = trim(totranslit( (string)$_COOKIE['dle_skin'], false, false ));

	if ($_COOKIE['dle_skin'] && is_dir( ROOT_DIR . '/templates/' . $_COOKIE['dle_skin'])) {
		$config['skin'] = $_COOKIE['dle_skin'];
	}
}

@header("Content-type: text/html; charset=" . $config['charset']);
define('TEMPLATE_DIR', ROOT_DIR . '/templates/' . $config['skin']);

date_default_timezone_set($config['date_adjust']);
$_TIME = time();

if (!$is_logged) {
	$member_id['user_group'] = 5;
}

//################# Определение групп пользователей
$user_group = get_vars('usergroup');
if (!$user_group) {
	$user_group = [];
	$db->query('SELECT * FROM ' . USERPREFIX . '_usergroups ORDER BY id ASC');
	while ($row = $db->get_row()) {
		$user_group[$row['id']] = [];
		foreach ($row as $key => $value) {
			$user_group[$row['id']][$key] = stripslashes($value);
		}
	}
	set_vars('usergroup', $user_group);
	$db->free();
}

//################# Определение категорий и их параметры
$cat_info = get_vars('category');
if (!is_array($cat_info)) {
	$cat_info = [];
	$db->query('SELECT * FROM ' . PREFIX . '_category ORDER BY posi ASC');
	while ($row = $db->get_row()) {
		$cat_info[$row['id']] = [];
		foreach ($row as $key => $value) {
			$cat_info[$row['id']][$key] = stripslashes($value);
		}
	}
	set_vars('category', $cat_info);
	$db->free();
}

$all_news = isset($_POST['all_news']) && intval($_POST['all_news']) > 0 ? intval($_POST['all_news']) : false;
$now_news = isset($_POST['now_news']) && intval($_POST['now_news']) > 0 ? intval($_POST['now_news']) : false;
$xf_post = isset($_POST['from_p']) && is_string($_POST['from_p']) ? $_POST['from_p'] : false;

$tpl = new dle_template();
$tpl->dir = TEMPLATE_DIR;

include ENGINE_DIR . '/dle_multixfield/site/news.filter.php';
$data = [];

$data['news'] = $tpl->result['content'];
$data['all_news'] = $all_news;
$data['now_news'] = $now_news;
$data['limit'] = intval($dle_multixfield_config['options']['news']);

echo json_encode($data);
?>