<?php
/**
 * DLE MultiXfield
 *
 * @copyright 2018 LazyDev
 * @version   1.0.0
 * @link      https://lazydev.pro
 */

defined('DATALIFEENGINE') || die('go your way stalker');

class classFilter
{
	private $db, $form_field_arr = [], $where, $dle_multixfield_config;
	
	function __construct($db, $dle_multixfield_config)
    {
		$this->db = $db;
		$this->dle_multixfield_config = $dle_multixfield_config;
	}
	
	function getCache($where, $seo = false)
	{
		$cache_hash = md5(serialize($where));
		
		$cache_prefix = $seo == false ? 'news_mx_' : 'mxs_';
		
		$cache_file = ENGINE_DIR . '/cache/' . $cache_prefix . $cache_hash . '.tmp';
		
		if (file_exists($cache_file)) {
			$buffer = file_get_contents($cache_file);
			
			$file_date = filemtime($cache_file);
			$file_date = time() - $file_date;
			
            if ($file_date > (180 * 60)) {
				$buffer = false;
				unlink($cache_file);
			}

			return $buffer;
		}
        
		return false;
	}
	
	public function setCache($data, $where, $seo = false)
	{	
		$cache_hash = md5(serialize($where));
		$cache_prefix = $seo == false ? 'news_mx_' : 'mxs_';
        
		file_put_contents(ENGINE_DIR . '/cache/' . $cache_prefix . $cache_hash . '.tmp', $data, LOCK_EX);
		@chmod(ENGINE_DIR . '/cache/' . $cache_prefix . $cache_hash . '.tmp', 0666);
	}
	
	private function filterData($xf = false)
	{
		if (!$xf) {
			$xf = $_GET['xf'];
		}
		
		$form_field = urldecode(strip_tags(str_ireplace(['<?', '?>', 'eval', '$', '@'], '', trim($xf))));
		
        if (dle_substr($form_field, -1, 1, 'utf-8') == '/') {
			$form_field = dle_substr($form_field, 0, -1, 'utf-8');
		}
		
		$form_field = explode('/', $form_field);
		$this->form_field_arr = [];
		foreach ($form_field as $val) {
			$val_arr = explode('=', $val);
			if ($val_arr[1] != '') {
				$this->form_field_arr[$val_arr[0]] = trim($val_arr[1]);
			}
		}
	}
	
	private function sqlWhere()
	{
		if ($this->form_field_arr) {
			$this->where = [];
			foreach ($this->form_field_arr as $key => $value) {
				$array_value = false;
				if (substr_count($value, ',')) {
					$array_value = explode(',', $value);
				}
				
                $key = $this->db->safesql($key);
				
                if (is_array($array_value)) {
					foreach($array_value as $index => &$val) {
						$val = $this->db->safesql($val);
						$xf_filter_arr[$key][] = "SUBSTRING_INDEX(SUBSTRING_INDEX(xfields, '{$key}|', -1 ), '||', 1) LIKE '%{$val}%'";
					}
					$this->where[] =  '(' . implode(' AND ', $xf_filter_arr[$key]) . ')';
				} elseif (is_scalar($value)) {
					$value = $this->db->safesql($value);
					$this->where[] = "SUBSTRING_INDEX(SUBSTRING_INDEX(xfields, '{$key}|', -1), '||', 1) LIKE '%{$value}%'";
				}
			}
            
			$this->where = implode(' AND ', $this->where);
		} else {
			$this->where = '';
		}
	}
	
	function returnSqlWhere()
	{
		if (!$this->where) {
			$this->sqlWhere();
		}
        
		return $this->where;
	}
	
	function returnFilterData ($xf = false)
	{
		if (!$this->form_field_arr) {
			$this->filterData($xf);
		}
		return $this->form_field_arr;
	}
	
	function getCategory()
	{
		return count($this->dle_multixfield_config['category']) > 0 ? " AND category REGEXP '[[:<:]](" . implode('|', $this->dle_multixfield_config['category']) . ")[[:>:]]'" : '';
	}
}

$classFilter = new classFilter($db, $dle_multixfield_config);
