<?php
/**
 * DLE MultiXfield
 *
 * @copyright 2018 LazyDev
 * @version   1.0.0
 * @link      https://lazydev.pro
 */

defined('DATALIFEENGINE') || die('go your way stalker');

global $classFilter;

include ENGINE_DIR . '/dle_multixfield/site/block.filter.php';
include ENGINE_DIR . '/dle_multixfield/config/config.php';

$template = '';
$xf = xfieldsload();
$xfield = [];
foreach ($xf as $key => $val) {
	$xfield[$val[0]] = $val[1];
}

if (is_object($classFilter)) {
	$form_field_arr = $classFilter->returnFilterData();
	$where = $classFilter->returnSqlWhere();
	$where = $where != '' ? ' AND ' . $where : '';
	$where .= $classFilter->getCategory();
} else {
    include ENGINE_DIR . '/dle_multixfield/site/class.filter.php';
}

if (is_object($classFilter)) {
	$getCache = $classFilter->getCache($where);
	if ($getCache) {
		echo $getCache;
		return;
	}
}

$xfield_config = count($dle_multixfield_config['xfield']) > 0 ? $dle_multixfield_config['xfield'] : [];
$xfield_config = array_flip($xfield_config);

$sql = $db->query("SELECT xfields FROM " . PREFIX . "_post WHERE xfields!='' AND approve='1' {$where}");
$xf_data = [];
$xf_count = [];

while ($row = $db->get_row($sql)) {
	$xf_news = xfieldsdataload($row['xfields']);
	foreach ($xf_news as $keys => $xf_value) {
		if ($xfield_config != '' && isset($xfield_config[$keys])) {
			$xf_array = explode(',', $xf_value);
			array_walk($xf_array, function($value, $key) use(&$xf_data, $keys, &$xf_count) {
				$v = mb_convert_case(trim($value), MB_CASE_TITLE, 'UTF-8');
				if (!$xf_data[$keys][$v]) {
					$xf_data[$keys][$v] = $v;
				}
				$xf_count[$keys][$v]++;
			});
		}
	}
}
$db->free($sql);

$remove_checked = [];
if (isset($_GET['xf']) && $_GET['xf'] != '') {
	$xf_data_duplicate = $xf_data;
	
	$template = $block_checked_template;
	
	$check_template_array = [];
	foreach ($xf_data_duplicate as $index => $value) {
		$check_item = explode(',', $form_field_arr[$index]);
		$check_item = array_flip($check_item);
        asort($xf_data_duplicate[$index]);
		array_walk($xf_data_duplicate[$index], function($item, $key) use($form_field_arr, $design_checked_template, $index, $xf_count, $check_item, &$check_template_array, &$remove_checked) {
			if (isset($check_item[$item])) {
				$url_array = [];
				foreach ($form_field_arr as $key_form => $value_form) {
					$temp_Array = explode(',', $value_form);
					$temp_Array = array_flip($temp_Array);
					unset($temp_Array[$item]);
					$temp_Array = array_flip($temp_Array);
					if ($temp_Array) {
						$url_array[$key_form] = $key_form . '=' . implode(',', $temp_Array);
					}
				}
				
				if ($url_array) {
					arsort($url_array);
				}
				
				$url = '/search/' . ($url_array ? implode('/', $url_array) . '/' : '');
				$check_template_array[] = str_replace(['{value}', '{key}', '{count}', '{url}'], [$item, $index, $xf_count[$index][$item], $url], $design_checked_template);
				$remove_checked[$index][$item] = $item;
			}
		}, ARRAY_FILTER_USE_BOTH);
	}
	
	$template = str_replace('{value}', implode($check_template_array), $template);
}

if (count($xf_data) != count($xfield_config)) {
	$resultDif = array_diff_key($xfield_config, $xf_data);
	$xf_data = $xf_data + $resultDif;
}

foreach ($xf_data as $index => $value) {
	if ($value) {
		$block_template_array = [];
		$template = $template . str_replace('{block-name}', $xfield[$index], $block_template);
        asort($xf_data[$index]);
		array_walk($xf_data[$index], function($item, $key) use($design_block_template, $index, $xf_count, $form_field_arr, $remove_checked, &$block_template_array) {
			if (!isset($remove_checked[$index][$item])) {
				if ($form_field_arr[$index]) {
					$temp_ = $form_field_arr;
					$temp_[$index] .= ',' . $item;
					$url = '/search/' . str_replace(['&', '%2C'], ['/', ','], http_build_query($temp_)) . '/';
				} else {
					if ($form_field_arr) {
						$temp_form_field = $form_field_arr;
						$temp_form_field[$index] = $item;
						arsort($temp_form_field);
						$url = '/search/' . str_replace(['&', '%2C'], ['/', ','], http_build_query($temp_form_field)) . '/';
					} else {
						$url = '/search/' . $index . '=' . $item . '/';
					}
				}
				$block_template_array[] = str_replace(['{value}', '{key}', '{count}', '{url}'], [$item, $index, $xf_count[$index][$item], $url], $design_block_template);
			}
		});
        
		if ($block_template_array) {
			$template = str_replace('{value}', implode($block_template_array), $template);
		} else {
			$template = str_replace('{value}', "<li class=\"not_filter\">Совпадений нет</li>", $template);
		}
	}
}

if (is_object($classFilter)) {
	$classFilter->setCache($template, $where);
}

echo $template;
