<?php
/**
 * DLE MultiXfield
 *
 * @copyright 2018 LazyDev
 * @version   1.0.0
 * @link      https://lazydev.pro
 */

defined('DATALIFEENGINE') || die('go your way stalker');

include ENGINE_DIR . '/dle_multixfield/config/config.php';
include ENGINE_DIR . '/dle_multixfield/site/class.filter.php';

$form_field_arr = $classFilter->returnFilterData($xf_post);
$where = $classFilter->returnSqlWhere();

if (empty($all_news)) {
	$url_form = str_replace(['&', '%2C'], ['/', ','], http_build_query($form_field_arr));

	if (substr($_SERVER['REQUEST_URI'], -1, 1) != '/') {
		if ($url_form) {
			$url_form .= '/';
		}
		header('HTTP/1.0 301 Moved Permanently');
		header("Location: /search/{$url_form}");
		die('Redirect');
	}
}

if ($where) {
	$where = ' AND ' . $where;
}

if (empty($all_news)) {
	if ($dle_multixfield_config['options']['index']) {
		$disable_index = true;
	}
	$metatagss = ['title' => [], 'description' => []];
	$xf = xfieldsload();
	foreach ($xf as $key => $val) {
		if ($form_field_arr[$val[0]]) {
			$metatagss['title'][] = $val[1] . ' ' . $form_field_arr[$val[0]];
			$metatagss['description'][] = $val[1] . ' ' . $form_field_arr[$val[0]];
		}
	}
	if (count($metatagss['title'])) {
		$metatags['title'] = 'Новости ' . implode(' ', $metatagss['title']);
		$metatags['description'] = 'Поиск новостей за ' . implode(' ', $metatagss['description']);
	}
}

$where .= $classFilter->getCategory();

$tpl->load_template('shortstory.tpl');

$dle_multixfield_config['options']['news'] = $dle_multixfield_config['options']['news'] ? $dle_multixfield_config['options']['news'] : 10;
$now_news = isset($now_news) ? $now_news + $dle_multixfield_config['options']['news'] : 0;

$cache_news = $classFilter->getCache([$where . $now_news]);
if ($cache_news) {
	$content = json_decode($cache_news, true);
	$tpl->result['content'] = $content['content'];
} else {
	$sql_result = $db->query("SELECT p.id, p.autor, p.date, p.short_story, p.full_story, p.xfields, p.title, p.category, p.alt_name, p.comm_num, p.allow_comm, p.fixed, p.tags, e.news_read, e.allow_rate, e.rating, e.vote_num, e.votes, e.view_edit, e.editdate, e.editor, e.reason FROM " . PREFIX . "_post p LEFT JOIN " . PREFIX . "_post_extras e ON (p.id=e.news_id) WHERE xfields!='' AND approve='1' {$where} LIMIT {$now_news}, {$dle_multixfield_config['options']['news']}");

	if (file_exists(ENGINE_DIR . '/classes/plugins.class.php')) {
		include_once (DLEPlugins::Check(ENGINE_DIR . '/modules/show.custom.php'));
	} else {
		include ENGINE_DIR . '/modules/show.custom.php';
	}
	
	if ($config['files_allow']) {
		if (strpos($tpl->result['content'], '[attachment=') !== false) {
			$tpl->result['content'] = show_attach($tpl->result['content'], $attachments);
		}
	}
	
	if ($tpl->result['content']) {
		$classFilter->setCache(json_encode(['content' => $tpl->result['content']]), [$where . $now_news]);
	}
}

if (empty($all_news)) {
	$count_news = $db->super_query("SELECT COUNT(*) as count FROM " . PREFIX . "_post WHERE xfields!='' AND approve='1' {$where}");
	$all_news = $count_news['count'];
}

if ($all_news > $dle_multixfield_config['options']['news'] && $now_news == 0) {
$url_form = urldecode(http_build_query($form_field_arr, '', '/'));
$tpl->result['content'] .=<<<HTML
<div class="bottom-nav ignore-select" id="bottom-nav">
	<div class="nav-load" id="nav-load"><div>Загрузить еще</div></div>
</div>
<script>
var all_news = {$all_news};
var now_news = {$now_news};
var from_p = "{$url_form}";
document.getElementById('bottom-nav').onclick = function() {
	var xmlHttp;
	if (window.XMLHttpRequest) {
		xmlHttp = new XMLHttpRequest();
	} else {
		xmlHttp = new ActiveXObject('Microsoft.XMLHTTP');
	}
	
	xmlHttp.onreadystatechange = function() { 
		if (xmlHttp.readyState == 4 && xmlHttp.status == 200) {
			var jsons = JSON.parse(xmlHttp.responseText);
			var after = document.createElement('div');
			after.innerHTML = jsons.news;
			now_news = jsons.now_news;
			all_news = jsons.all_news;
			
			if (jsons.all_news <= jsons.now_news+jsons.limit) {
				document.getElementById('bottom-nav').remove();
				while (after.childNodes.length > 0) {
					document.getElementById('dle-content').append(after.childNodes[0]);
				}
			} else {
				while (after.childNodes.length > 0) {
					document.getElementById('bottom-nav').parentNode.insertBefore(after.childNodes[0], document.getElementById('bottom-nav'));
				}
			}
		}
	}
	xmlHttp.open('POST', '/engine/dle_multixfield/ajax/filter.php', true);
	xmlHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=utf-8');
	xmlHttp.send('all_news='+all_news+'&now_news='+now_news+'&from_p='+from_p);
};
</script>
HTML;
}

if ($config['speedbar'] && $metatags['title']) {
	$s_navigation = "<span itemscope itemtype=\"http://data-vocabulary.org/Breadcrumb\"><a href=\"{$config['http_home_url']}\" itemprop=\"url\"><span itemprop=\"title\">" . $config['short_title'] . "</span></a></span>";
	
	$s_navigation .= " {$config['speedbar_separator']} " . $metatags['title'];
	
	$tpl->load_template('speedbar.tpl');
	$tpl->set('{speedbar}', '<span id="dle-speedbar">' . stripslashes($s_navigation) . '</span>');
	$tpl->compile('speedbar');
	$tpl->clear();
	$config['speedbar'] = false;
}
